#include <ppl.h>
#include <random>
#include <iostream>

using namespace Concurrency;
using namespace std;

// 3 ǥ
struct Point
{
	int X;
	int Y;
	int Z;
};

//  ǥ Ŭ Ÿ ϴ Լ
size_t euclidean_distance(const Point& p1, const Point& p2)
{
	int dx = p1.X - p2.X;
	int dy = p1.Y - p2.Y;
	int dz = p1.Z - p2.Z;
	return static_cast<size_t>(sqrt((dx*dx) + (dy*dy) + (dz*dz)));
}

int wmain()
{
	// Ÿ  ߽ ǥ
	const Point center = { 3, 2, 7 };

	//  ǥ 
	vector<Point> values(7);
	mt19937 random(42);
	generate(begin(values), end(values), [&random] {
		Point p = { random() % 10, random() % 10, random() % 10 };
		return p;
	});

	//  ǥ 
	wcout << "Before sorting:" << endl;
	for_each(begin(values), end(values), [center](const Point& p) {
		wcout << L'(' << p.X << L"," << p.Y << L"," << p.Z
			<< L") D = " << euclidean_distance(p, center) << endl;
	});
	wcout << endl;

	// ߽κ Ÿ  
	parallel_radixsort(begin(values), end(values),
		[center](const Point& p) -> size_t {
			return euclidean_distance(p, center);
	});

	// ĵ ǥ 
	wcout << "After sorting:" << endl;
	for_each(begin(values), end(values), [center](const Point& p) {
		wcout << L'(' << p.X << L"," << p.Y << L"," << p.Z
			<< L") D = " << euclidean_distance(p, center) << endl;
	});
	wcout << endl;
}
