#include <ppl.h>
#include <random>
#include <iostream>
#include <windows.h>

using namespace Concurrency;
using namespace std;

// ޹ Լ ȣϰ Լ  ҿ ð ȯ
template <class Function>
__int64 time_call(Function&& f)
{
	__int64 begin = GetTickCount();
	f();
	return GetTickCount() - begin;
}

const size_t DATASET_SIZE = 10000000;


//      ͼ Ͽ ȯ
vector<size_t> GetData()
{
	vector<size_t> data(DATASET_SIZE);
	generate(begin(data), end(data), mt19937(42));
	return data;
}

int wmain()
{
	// std::sort Լ ̿ 
	auto data = GetData();
	wcout << L"Testing std::sort...";
	auto elapsed = time_call([&data] { sort(begin(data), end(data)); });
	wcout << L" took " << elapsed << L" ms." <<endl;

	// parallel_sort Լ ̿ 
	data = GetData();
	wcout << L"Testing Concurrency::parallel_sort...";
	elapsed = time_call([&data] { parallel_sort(begin(data), end(data)); });
	wcout << L" took " << elapsed << L" ms." <<endl;

	// parallel_buffered_sort Լ ̿ 
	data = GetData();
	wcout << L"Testing Concurrency::parallel_buffered_sort...";
	elapsed = time_call([&data] { parallel_buffered_sort(begin(data), end(data)); });
	wcout << L" took " << elapsed << L" ms." <<endl;

	// parallel_radixsort Լ ̿ 
	data = GetData();
	wcout << L"Testing Concurrency::parallel_radixsort...";
	elapsed = time_call([&data] { parallel_radixsort(begin(data), end(data)); });
	wcout << L" took " << elapsed << L" ms." <<endl;
}
